postgresql-14 (14.23-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2152636).

    + A dump/restore is not required for those running 14.X.

    + However, if you are upgrading from a version earlier than 14.19, see
      those release notes as well please.

    + Prevent unbounded recursion while processing startup packets

      A malicious client could crash the connected backend by alternating
      rejected SSL and GSS encryption requests indefinitely. (CVE-2026-6479)

    + Fix assorted integer overflows in memory-allocation calculations

      Various places were incautious about the possibility of integer overflow
      in calculations of how much memory to allocate. Overflow would lead to
      allocating a too-small buffer which the caller would then write past the
      end of. This would at least trigger server crashes, and probably could
      be exploited for arbitrary code execution. In many but by no means all
      cases, the hazard exists only in 32-bit builds. (CVE-2026-6473)

    + Reject over-length options in ts_headline()

      The StartSel, StopSel and FragmentDelimiter strings must not exceed 32Kb
      in length, but this was not checked for. An over-length value would
      typically crash the server. (CVE-2026-6473)

    + Guard against malicious time zone names in timeofday() and pg_strftime()

      A crafted time zone setting could pass % sequences to snprintf(),
      potentially causing crashes or disclosure of server memory. Another path
      to similar results was to overflow the limited-size output buffer used
      by pg_strftime(). (CVE-2026-6474)

    + When creating a multirange type, ensure the user has CREATE privilege on
      the schema specified for the multirange type

      The multirange type can be put into a different schema than its parent
      range type, but we neglected to apply the required privilege check when
      doing so. (CVE-2026-6472)

    + Use timing-safe string comparisons in authentication code

      Use timingsafe_bcmp() instead of memcpy() or strcmp() when checking
      passwords, hashes, etc. It is not known whether the data dependency of
      those functions is usefully exploitable in any of these places, but in
      the interests of safety, replace them. (CVE-2026-6478)

    + Mark PQfn() as unsafe, and avoid using it within libpq

      For a non-integral result type, PQfn() is not passed the size of the
      output buffer, so it cannot check that the data returned by the server
      will fit. A malicious server could therefore overwrite client memory.
      This is unfixable without an API change, so mark the function as
      deprecated.  Internally to libpq, use a variant version that can apply
      the missing check. (CVE-2026-6477)

    + Prevent path traversal in pg_basebackup and pg_rewind

      These applications failed to validate output file paths read from their
      input, so that a malicious source could overwrite any file writable by
      these applications. Constrain where data can be written by rejecting
      paths that are absolute or contain parent-directory references.
      (CVE-2026-6475)

    + Guard against field overflow within contrib/intarray's query_int type
      and contrib/ltree's ltxtquery type

      Parsing of these query structures did not check for overflow of 16-bit
      fields, so that construction of an invalid query tree was possible. This
      can crash the server when executing the query. (CVE-2026-6473)

    + Guard against overly long values of contrib/ltree's lquery type

      Values with more than 64K items caused internal overflows, potentially
      resulting in stack smashes or wrong answers. (CVE-2026-6473)

    + Prevent SQL injection and buffer overruns in contrib/spi

      check_foreign_key() was insufficiently careful about quoting key values,
      and also used fixed-length buffers for constructing queries. While this
      module is only meant as example code, it still shouldn't contain such
      dangerous errors. (CVE-2026-6637)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-23.html.

  * d/postgresql-14.NEWS: update NEWS file.

 -- Athos Ribeiro <athos@ubuntu.com>  Fri, 15 May 2026 09:22:59 -0300

postgresql-14 (14.22-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2127668).

    + This release encompasses changes from upstream's 14.21 and 14.22
      releases. The former contains fixes for 4 CVEs (among other things), and
      the latter was a hotfix for regressions introcuced in 14.21.

    + A dump/restore is not required for those running 14.X.

    + However, if you are upgrading from a version earlier than 14.19, see
      those release notes as well please.

    + Guard against unexpected dimensions of oidvector/int2vector (Tom Lane)

      These data types are expected to be 1-dimensional arrays containing no
      nulls, but there are cast pathways that permit violating those
      expectations. Add checks to some functions that were depending on those
      expectations without verifying them, and could misbehave in consequence.
      (CVE-2026-2003)

    + Harden selectivity estimators against being attached to operators that
      accept unexpected data types (Tom Lane)

      contrib/intarray contained a selectivity estimation function that could
      be abused for arbitrary code execution, because it did not check that
      its input was of the expected data type. Third-party extensions should
      check for similar hazards and add defenses using the technique intarray
      now uses. Since such extension fixes will take time, we now require
      superuser privilege to attach a non-built-in selectivity estimator to an
      operator. (CVE-2026-2004)

    + Fix buffer overrun in contrib/pgcrypto's PGP decryption functions
      (Michael Paquier)

      Decrypting a crafted message with an overlength session key caused a
      buffer overrun, with consequences as bad as arbitrary code execution.
      (CVE-2026-2005)

    + Fix inadequate validation of multibyte character lengths (Thomas Munro,
      Noah Misch)

      Assorted bugs allowed an attacker able to issue crafted SQL to overrun
      string buffers, with consequences as bad as arbitrary code execution.
      After these fixes, applications may observe “invalid byte sequence for
      encoding” errors when string functions process invalid text that has
      been stored in the database. (CVE-2026-2006)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-21.html and
      https://www.postgresql.org/docs/14/release-14-22.html.

  * d/postgresql-14.NEWS: Update.

 -- Athos Ribeiro <athos@ubuntu.com>  Wed, 25 Feb 2026 11:13:13 -0300

postgresql-14 (14.20-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2127667).

    + A dump/restore is not required for those running 14.X.

    + However, if you are upgrading from a version earlier than 14.19, see
      those release notes as well please.

    + Check for CREATE privileges on the schema in CREATE STATISTICS (Jelte
      Fennema-Nio)

      This omission allowed table owners to create statistics in any schema,
      potentially leading to unexpected naming conflicts. (CVE-2025-12817)

    + Avoid integer overflow in allocation-size calculations within libpq
      (Jacob Champion)

      Several places in libpq were not sufficiently careful about computing
      the required size of a memory allocation. Sufficiently large inputs
      could cause integer overflow, resulting in an undersized buffer, which
      would then lead to writing past the end of the buffer. (CVE-2025-12818)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-20.html.

  * d/postgresql-14.NEWS: Update NEWS file.

 -- Athos Ribeiro <athos@ubuntu.com>  Mon, 24 Nov 2025 10:34:10 -0300

postgresql-14 (14.19-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2112531).

    + A dump/restore is not required for those running 14.X.

    + However, if you have any BRIN numeric_minmax_multi_ops indexes, it is
      advisable to reindex them after updating. Keep reading for further
      information.

    + Also, if you are upgrading from a version earlier than 14.18, see those
      release notes as well please.

    + Tighten security checks in planner estimation functions (Dean Rasheed)

      The fix for CVE-2017-7484, plus followup fixes, intended to prevent
      leaky functions from being applied to statistics data for columns that
      the calling user does not have permission to read. Two gaps in that
      protection have been found. One gap applies to partitioning and
      inheritance hierarchies where RLS policies on the tables should restrict
      access to statistics data, but did not.

      The other gap applies to cases where the query accesses a table via a
      view, and the view owner has permissions to read the underlying table
      but the calling user does not have permissions on the view. The view
      owner's permissions satisfied the security checks, and the leaky
      function would get applied to the underlying table's statistics before
      we check the calling user's permissions on the view. This has been fixed
      by making security checks on views occur at the start of planning. That
      might cause permissions failures to occur earlier than before.
      (CVE-2025-8713)

    + Prevent pg_dump scripts from being used to attack the user running the
      restore (Nathan Bossart)

      Since dump/restore operations typically involve running SQL commands as
      superuser, the target database installation must trust the source
      server. However, it does not follow that the operating system user who
      executes psql to perform the restore should have to trust the source
      server. The risk here is that an attacker who has gained superuser-level
      control over the source server might be able to cause it to emit text
      that would be interpreted as psql meta-commands. That would provide
      shell-level access to the restoring user's own account, independently of
      access to the target database.

      To provide a positive guarantee that this can't happen, extend psql with
      a restrict command that prevents execution of further meta-commands,
      and teach pg_dump to issue that before any data coming from the source
      server. (CVE-2025-8714)

    + Convert newlines to spaces in names included in comments in pg_dump
      output (Noah Misch)

      Object names containing newlines offered the ability to inject arbitrary
      SQL commands into the output script. (Without the preceding fix,
      injection of psql meta-commands would also be possible this way.)
      CVE-2012-0868 fixed this class of problem at the time, but later work
      reintroduced several cases. (CVE-2025-8715)

    + Fix incorrect distance calculation in BRIN numeric_minmax_multi_ops
      support function (Peter Eisentraut, Tom Lane)

      The results were sometimes wrong on 64-bit platforms, and wildly wrong
      on 32-bit platforms. This did not produce obvious failures because the
      logic is only used to choose how to merge values into ranges; at worst
      the index would become inefficient and bloated. Nonetheless it's
      recommended to reindex any BRIN indexes that use the
      numeric_minmax_multi_ops operator class.

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-19.html.

  * d/postgresql-14.NEWS: Update.

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 25 Aug 2025 22:04:43 -0300

postgresql-14 (14.18-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2110377).

    + A dump/restore is not required for those running 14.X.

    + However, if you have any self-referential foreign key constraints on
      partitioned tables, it may be necessary to recreate those constraints to
      ensure that they are being enforced correctly. Follow the steps below to
      do so.

    + Also, if you have any BRIN bloom indexes, it may be advisable to reindex
      them after updating. Follow the steps below to do so.

    + Also, if you are upgrading from a version earlier than 14.14, see those
      release notes as well please.

    + Avoid one-byte buffer overread when examining invalidly-encoded strings
      that are claimed to be in GB18030 encoding (Noah Misch, Andres Freund)

      While unlikely, a SIGSEGV crash could occur if an incomplete multibyte
      character appeared at the end of memory. This was possible both in the
      server and in libpq-using applications. (CVE-2025-4207)

    + Handle self-referential foreign keys on partitioned tables correctly
      (Álvaro Herrera)

      Creating or attaching partitions failed to make the required catalog
      entries for a foreign-key constraint, if the table referenced by the
      constraint was the same partitioned table. This resulted in failure to
      enforce the constraint fully.

      To fix this, you should drop and recreate any self-referential foreign
      keys on partitioned tables, if partitions have been created or attached
      since the constraint was created. Bear in mind that violating rows might
      already be present, in which case recreating the constraint will fail,
      and you'll need to fix up those rows before trying again.

    + Avoid data loss when merging compressed BRIN summaries in
      brin_bloom_union() (Tomas Vondra)

      The code failed to account for decompression results not being identical
      to the input objects, which would result in failure to add some of the
      data to the merged summary, leading to missed rows in index searches.

      This mistake was present back to v14 where BRIN bloom indexes were
      introduced, but this code path was only rarely reached then. It's
      substantially more likely to be hit in v17 because parallel index builds
      now use the code.

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-18.html.

  * d/postgresql-14.NEWS: Update.

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Sun, 11 May 2025 06:15:54 -0300

postgresql-14 (14.17-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2099900).

    + This release encompasses changes from upstream's 14.16 and 14.17
      releases.  The former contains fixes for CVE-2025-1094 (among other
      things), and the latter was a hotfix for a problem caused by the CVE
      fix from 14.16.

    + A dump/restore is not required for those running 14.X.

    + However, if you are upgrading from a version earlier than 14.14, see
      those release notes as well please.

    + Harden PQescapeString and allied functions against invalidly-encoded
      input strings (Andres Freund, Noah Misch)

      Data-quoting functions supplied by libpq now fully check the encoding
      validity of their input. If invalid characters are detected, they report
      an error if possible. For the ones that lack an error return convention,
      the output string is adjusted to ensure that the server will report
      invalid encoding and no intervening processing will be fooled by bytes
      that might happen to match single quote, backslash, etc.

      The purpose of this change is to guard against SQL-injection attacks
      that are possible if one of these functions is used to quote crafted
      input. There is no hazard when the resulting string is sent directly to
      a PostgreSQL server (which would check its encoding anyway), but there
      is a risk when it is passed through psql or other client-side code.
      Historically such code has not carefully vetted encoding, and in many
      cases it's not clear what it should do if it did detect such a problem.

      This fix is effective only if the data-quoting function, the server, and
      any intermediate processing agree on the character encoding that's being
      used. Applications that insert untrusted input into SQL commands should
      take special care to ensure that that's true.

      Applications and drivers that quote untrusted input without using these
      libpq functions may be at risk of similar problems. They should first
      confirm the data is valid in the encoding expected by the server.

      The PostgreSQL Project thanks Stephen Fewer for reporting this problem.
      (CVE-2025-1094)

    + Improve behavior of libpq's quoting functions (Andres Freund, Tom Lane)

      The changes made for CVE-2025-1094 had one serious oversight:
      PQescapeLiteral() and PQescapeIdentifier() failed to honor their string
      length parameter, instead always reading to the input string's trailing
      null. This resulted in including unwanted text in the output, if the
      caller intended to truncate the string via the length parameter. With
      very bad luck it could cause a crash due to reading off the end of
      memory.

      In addition, modify all these quoting functions so that when invalid
      encoding is detected, an invalid sequence is substituted for just the
      first byte of the presumed character, not all of it. This reduces the
      risk of problems if a calling application performs additional processing
      on the quoted string.

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-16.html and
      https://www.postgresql.org/docs/14/release-14-17.html.

  * d/postgresql-14.NEWS: Update.

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 24 Feb 2025 13:09:01 -0300

postgresql-14 (14.15-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2085196).

    + This release encompasses changes from upstream's 14.14 and 14.15
      releases.  The former contains fixes for 4 CVEs (among other
      things), and the latter was hotfix for a problem caused by one of
      the CVE fixes from 14.14.

    + A dump/restore is not required for those running 14.X.

    + However, if you are upgrading from a version earlier than 14.12, see
      those release notes as well please.

    + Ensure cached plans are marked as dependent on the calling role when
      RLS applies to a non-top-level table reference (Nathan Bossart)

      If a CTE, subquery, sublink, security invoker view, or coercion
      projection in a query references a table with row-level security
      policies, we neglected to mark the resulting plan as potentially
      dependent on which role is executing it.  This could lead to later query
      executions in the same session using the wrong plan, and then returning
      or hiding rows that should have been hidden or returned instead.

      The PostgreSQL Project thanks Wolfgang Walther for reporting this
      problem.
      (CVE-2024-10976)

    + Make libpq discard error messages
      received during SSL or GSS protocol negotiation (Jacob Champion)

      An error message received before encryption negotiation is completed
      might have been injected by a man-in-the-middle, rather than being real
      server output.  Reporting it opens the door to various security hazards;
      for example, the message might spoof a query result that a careless user
      could mistake for correct output.  The best answer seems to be to
      discard such data and rely only on libpq's own report of the connection
      failure.

      The PostgreSQL Project thanks Jacob Champion for reporting this
      problem.
      (CVE-2024-10977)

    + Fix unintended interactions between SET SESSION AUTHORIZATION
      and SET ROLE (Tom Lane)

      The SQL standard mandates that SET SESSION AUTHORIZATION have a
      side-effect of doing SET ROLE NONE.  Our implementation of that was
      flawed, creating more interaction between the two settings than
      intended.  Notably, rolling back a transaction that had done SET SESSION
      AUTHORIZATION would revert ROLE to NONE even if that had not been the
      previous state, so that the effective user ID might now be different
      from what it had been before the transaction.  Transiently setting
      session_authorization in a function SET clause had a similar effect.  A
      related bug was that if a parallel worker inspected
      current_setting('role'), it saw none even when it should see something
      else.

      The PostgreSQL Project thanks Tom Lane for reporting this problem.
      (CVE-2024-10978)

    + Prevent trusted PL/Perl code from changing environment variables
      (Andrew Dunstan, Noah Misch)

      The ability to manipulate process environment variables such as PATH
      gives an attacker opportunities to execute arbitrary code.  Therefore,
      trustedPLs must not offer the ability to do that.  To fix plperl,
      replace %ENV with a tied hash that rejects any modification attempt with
      a warning.  Untrusted plperlu retains the ability to change the
      environment.

      The PostgreSQL Project thanks Coby Abrams for reporting this problem.
      (CVE-2024-10979)

    + Restore functionality of ALTER {ROLE|DATABASE} SET
      role (Tom Lane, Noah Misch)

      The fix for CVE-2024-10978 accidentally caused settings for role to
      not be applied if they come from non-interactive sources, including
      previous ALTER {ROLE|DATABASE} commands and the PGOPTIONS environment
      variable.

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-14.html and
      https://www.postgresql.org/docs/14/release-14-15.html.

  * d/postgresql-14.NEWS: Update.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 25 Nov 2024 16:05:41 -0500

postgresql-14 (14.13-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2076183).

    + A dump/restore is not required for those running 14.X.

    + However, if you are upgrading from a version earlier than 14.12, see
      those release notes as well please.

    + Prevent unauthorized code execution during pg_dump (Masahiko Sawada)

      An attacker able to create and drop non-temporary objects could inject
      SQL code that would be executed by a concurrent pg_dump session with the
      privileges of the role running pg_dump (which is often a superuser).
      The attack involves replacing a sequence or similar object with a view
      or foreign table that will execute malicious code.  To prevent this,
      introduce a new server parameter restrict_nonsystem_relation_kind that
      can disable expansion of non-builtin views as well as access to foreign
      tables, and teach pg_dump to set it when available.  Note that the
      attack is prevented only if both pg_dump and the server it is dumping
      from are new enough to have this fix.

      The PostgreSQL Project thanks Noah Misch for reporting this problem.
      (CVE-2024-7348)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-13.html.

  * d/postgresql-14.NEWS: Update.
  * d/p/focal-arm64-outline-atomics: refresh patch.

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 06 Aug 2024 15:14:44 -0300

postgresql-14 (14.12-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2067388).

    + A dump/restore is not required for those running 14.X.

    + However, a security vulnerability was found in the system views
      pg_stats_ext and pg_stats_ext_exprs, potentially allowing
      authenticated database users to see data they shouldn't. If this is of
      concern in your installation, follow the steps below to rectify it.

    + Also, if you are upgrading from a version earlier than 14.11, see
      those release notes as well please.

    + Restrict visibility of pg_stats_ext and pg_stats_ext_exprs entries
      to the table owner (Nathan Bossart)

      These views failed to hide statistics for expressions that involve
      columns the accessing user does not have permission to read. View
      columns such as most_common_vals might expose security-relevant
      data. The potential interactions here are not fully clear, so in the
      interest of erring on the side of safety, make rows in these views
      visible only to the owner of the associated table.

      The PostgreSQL Project thanks Lukas Fittl for reporting this
      problem.

      By itself, this fix will only fix the behavior in newly initdb'd
      database clusters. If you wish to apply this change in an existing
      cluster, you will need to do the following:

        - In each database of the cluster, run the
          /usr/share/postgresql/14/fix-CVE-2024-4317.sql script as superuser. In
          psql this would look like:

            i /usr/share/postgresql/14/fix-CVE-2024-4317.sql

          It will not hurt to run the script more than once.

        - Do not forget to include the template0 and template1 databases,
          or the vulnerability will still exist in databases you create
          later. To fix template0, you'll need to temporarily make it accept
          connections. Do that with:

            ALTER DATABASE template0 WITH ALLOW_CONNECTIONS true;

          and then after fixing template0, undo it with:

            ALTER DATABASE template0 WITH ALLOW_CONNECTIONS false;

      (CVE-2024-4317)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-12.html

  * d/postgresql-14.NEWS: Update.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Tue, 28 May 2024 09:51:10 -0400

postgresql-14 (14.11-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * New upstream version (LP: #2052850).

    + A dump/restore is not required for those running 14.X.

    + However, one bug was fixed that could have resulted in corruption of
      GIN indexes during concurrent updates.  If you suspect such
      corruption, reindex affected indexes after installing this update.

    + Also, if you are upgrading from a version earlier than 14.10, see
      those release notes as well please.

    + Tighten security restrictions within REFRESH MATERIALIZED
      VIEW CONCURRENTLY (Heikki Linnakangas)

      One step of a concurrent refresh command was run under weak security
      restrictions.  If a materialized view's owner could persuade a
      superuser or other high-privileged user to perform a concurrent
      refresh on that view, the view's owner could control code executed
      with the privileges of the user running REFRESH.
      Fix things so that all user-determined code is run as the view's
      owner, as expected.

      The only known exploit for this error does not work in PostgreSQL
      16.0 and later, so it may be that v16 is not vulnerable in practice.

      The PostgreSQL Project thanks Pedro Gallegos for reporting this
      problem.
      (CVE-2024-0985)

    + Details about these and many further changes can be found at:
      https://www.postgresql.org/docs/14/release-14-11.html

  * d/postgresql-14.NEWS: Update.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 09 Feb 2024 19:49:08 -0500

# For older changelog entries, run 'apt-get changelog postgresql-doc-14'
